Unit Err;

INTERFACE

type      cproc = function (flags, err : byte) : byte;
          rproc = procedure;

Procedure DoRunTime  (proc : rproc);   { Installe le gestionnaire runtime  }
Procedure DoCritical (proc : cproc);   { Installe le gestionnaire critical }

IMPLEMENTATION

Uses  crt,             { readkey   }
      strings,         { strpas    }
      dos;             { setintvec }

Var   oldexit      : pointer;         { pointe sur l'ancienne sortie      }
      ProcCritical : cproc;           { Gestionnaire Critical err perso   }
      UsrRuntime   : procedure;       { Gestionnaire runtime  err perso   }

{}
{ Convertit un pointeur en hexadcimal                                    }
{}
Function  PHexa (n : pointer) : string;
var   i  : byte;
      s  : string[9];
const hex : array[0..15] of char = '0123456789ABCDEF';
begin
  s[0] := #8;
  for i := 8 downto 1 do begin
    s[i] := hex[longint(n) AND 15];
    longint(n) := longint(n) shr 4;
  end;
  insert (':', s, 5);
  Phexa := s;
end;

{}
{ Gestionnaire d'erreurs critiques par dfaut                             }
{}
Function myerr (flags, err : byte) : byte; far;
const errs : array[0..12] of pchar = (
      'Disquette protge en criture',
      'Accs  un priphrique inconnu',
      'Lecteur non prt',
      'Instruction inconnue',
      'Erreur CRC',
      'Largeur de donnes incorrecte',
      'Recherche infructueuse',
      'Type de priphrique inconnu',
      'Secteur non trouv',
      'Plus de papier dans l''imprimante',
      'Erreur d''criture',
      'Erreur de lecture',
      'Erreur gnrale'
      );
      tyerr : array[boolean] of string[12]= (
        'de lecture', 'd''criture' );
begin
  if flags and $8000 = 0 then begin
    Write (chr(lo(flags)+65), ': Erreur ',            { Lecteur concern }
           tyerr[boolean (flags and 1)], ' ');        { Lecture/Ecriture }
  end;

  Writeln (strpas(errs[err]), ' [erreur ', err, ']');
  Write ('[A]bandon, [R]eprise, [Q]uitter, [E]chec :');
  repeat
    case readkey of
      #0 : readkey;
      'A', 'a' : begin myerr := 0; break; end;
      'R', 'r' : begin myerr := 1; break; end;
      'Q', 'q' : begin myerr := 2; break; end;
      'E', 'e' : begin myerr := 3; break; end;
    end;
  until false;
  Writeln;
end;

{}
{ Gestionnaire d'erreurs runtime par dfaut                               }
{}
Procedure Newexit; far;
CONST err : array[1..46] of pchar = (
       #001'Numro de fonction invalide',
       #002'Fichier introuvable',
       #003'Chemin introuvable',
       #004'Trop de fichiers ouverts',
       #005'Accs interdit au fichier',
       #006'Handle invalide',
       #012'Accs au fichier invalide',
       #015'Unit de disque invalide',
       #016'Supression de rpertoire impossible',
       #017'Impossible de renommer entre deux units',
       #018'Pas plus de fichiers',
       #100'Erreur de lecture disque',
       #101'Erreur d''criture disque',
       #102'Fichier non assign',
       #103'Fichier non ouvert',
       #104'Fichier interdit en lecture',
       #105'Fichier interdit en criture',
       #106'Format numrique invalide',
       #150'Le disque est en lecture seule',
       #151'Structure d''accs disque invalide',
       #152'Lecteur non prt',
       #154'Erreur de CRC dans les donnes',
       #156'Erreur d''accs disque',
       #157'Type de mdia inconnu',
       #158'Secteur introuvable',
       #159'Plus de papier dans l''imprimante',
       #160'Faute d''criture sur priphrique',
       #161'Faute de lecture sur priphrique',
       #162'*** Dficience matrielle grave ***',
       #200'Division par zro',
       #201'Dpassement de capacit',
       #202'Dbordement de pile',
       #203'Espace mmoire satur',
       #204'Opration de pointeur invalide',
       #205'Dpassement sur opration relle',
       #206'Dpassement sur opration relle',
       #207'Opration relle invalide',
       #208'Gestionnaire d''overlay non install',
       #209'Erreur de lecture de l''overlay',
       #210'Objet non initialis',
       #211'Appel  une mthode non dfinie',
       #212'Stream registration error',
       #213'Collection index out of range',
       #214'Collection overflow error',
       #215'Dpassement arythmetique',
       #216'*** Erreur gnerale de protection ***' );
VAR   s : string;
      i : byte;
BEGIN
  If errorAddr <> NIL then BEGIN
    If @UsrRunTime <> NIL then UsrRunTime;
    if erroraddr <> NIL then begin
      s := 'Erreur inconnue';
      for i := 1 to 46 do
      if ord(err[i][0]) = exitcode then s := strpas(pchar(@err[i][1]));
      Writeln (s, ' [erreur ', exitcode, '] au point ', Phexa(ErrorAddr));

      ExitCode := 0;
      ErrorAddr := NIL;
    end;
  end;
  Exitproc := OldExit;
END;

{}
{ Gestionnaire d'erreurs Critical error. Lance la procdure utilisateur   }
{}
Procedure critical; far;
assembler; asm
  pusha                             { Sauver tous les registres }
  push ds
  push es
  push ax
  push di                             { Passer le code d'erreur }
  mov  dx, seg @data             { Charge le segment de donnes }
  mov  ds, dx
  call dword ptr [procCritical]          { Appeler la procdure }
  mov  cs:offset @z, al                  { Sauver le rsultat   }

  pop  es
  pop  ds                          { Restaurer ts les registres }
  popa
  mov  al, byte ptr cs:offset @z        { Retrouver le rsultat }
  iret
@z:end;    { utiliser l'octet pris par le RETF pour le rsultat }

{}
{ Met en place l'interception RUNTIME ERROR.                              }
{ Si proc <> NIL, alors appelera la procdure en question ds qu'il y     }
{ aura une runtime error                                                  }
{}
Procedure DoRunTime (proc : rproc);
Begin
  oldexit    := exitproc;
  exitproc   := @newexit;
  usrRuntime := proc;
end;

{}
{ Met en place l'interception DOS CRITICAL.                               }
{ Si proc = NIL, alors utilise le gestionnaire d'erreurs par dfaut       }
{ intgr myerr.                                                          }
{}
Procedure DoCritical (proc : cproc);
Begin
  SetIntVec ($24, @critical);
  if @proc = NIL then proccritical := myerr else proccritical := proc;
end;

END.