MAIN     SEGMENT BYTE
         ASSUME CS:MAIN,DS:MAIN,SS:NOTHING

                Org 100h

; ********** On copie le boot sur la disquette **************
Start:          Mov ax,cs
                Mov es,ax
                Mov bx,7C00h
                Mov ax,0301h
                Mov cx,0001h
                Mov dx,0000h
                Int 13h
                Mov ah,09h
                Mov dx,Offset Good
                Int 21h               ; pour une fois a va !
                Mov ax,4C00h
                Int 21h               ; on quitte sans message d'erreur.
Good            Db 'Le nouveau boot est maintenant sur la disquette','$'

                Org 7C00h
                Jmp Boot

; ** D'abord pleins pleins pleins de rglage pour le BIOS et le DOS **
;  Je rappelle que cette partie n'est pas indispensable.
My_ID           Db 'Loll    ' ; important : 8 octets pour ID.
Sec_Size        Dw 512        ; 512 octets/secteur
Secs_per_clust  Db 02         ; 2 secteurs/cluster
Fat_start       Dw 0          ; secteur de dpart pour la 1ere FAT
Fat_Count       Db 0          ; nbr de FAT sur le disque
Root_Entries    Dw 70h        ; nbr entres sur le rep racine
Sec_Count       Dw 2880       ; nbr de secteurs sur le Disk
Disk_ID         Db 0FDh       ; identification (FDh=360k ...)
Secs_per_fat    Dw 0          ; nombre de secteurs pour la FAT
Secs_per_trk    Dw 18         ; nbr de secteurs pour 1 piste
Heads           Dw 2          ; nbr de ttes
Hidden_secs     Dw 0          ; nbr de secteurs cachs
Noheadloaded    Db 0          ; octet 1 spcifi : tte non charge
HeadLoaded      Db 0          ; octet 2 spcifi : tte charg,mode DMA
TimeMotor       Db 0          ; temps avant que le moteur ne tourne (horloge)
Oct_per_sect    Db 0          ; nbr octets par sect.(0=128, 1=256...)
Lastsectnbr     Db 12h        ; dernier numro de secteur sur une piste.
LargeRW         Db 0          ; largeur sur les secteurs pour lecture/critue
LengthData      Db 0          ; longueur des donnes de transfert
LengthFormat    Db 0          ; longueur entre les secteurs pour le formatage
Value           Db 0          ; Valeur stocke dans chaque octet au moment du formatage
TimePos         Db 1          ; Temps en ms de positionnement d'une tte
StartMotor      Db 0          ; Temps de dmarrage du moteur, en unit d'1/8 de seconde.
Head            Db 0

; ************* et puis enfin on programme le boot ***************
; *********** D'abord les variables et les sous-progs ************
SaveOfs         Dw 0
CursY           Db 0
CursX           Db 0
Attrib          Db 0
RAMWrite:       Mov SaveOfs,dx
                Mov cx,0
                Mov ax,0B800h
                Mov es,ax
Affiche:        Mov al,CursY
                Mov ah,0
                Mov bx,80
                Mul bx
                Mov bl,CursX
                Mov bh,0
                Add ax,bx
                Mov bx,2
                Mul bx
                Mov dx,ax       ; Dx = CursX+CursY*80*2
                Mov ah,Attrib
                Mov bx,SaveOfs
                Add bx,cx       ; Bx = Ofs+Depl
                Mov al,Byte ptr ds:[bx]
                Cmp al,'$'
                Jz Fin
                Inc cx
                Mov bx,dx
                Mov Word ptr es:[bx],ax   ; On copie Attribut + caractre
                Inc Byte ptr [CursX]
                Cmp CursX,81
                Jnz Affiche
                Xor al,al
                Mov Byte ptr [CursX],al
                Inc [CursY]
                Cmp CursY,26
                Jnz Affiche
                Mov Byte ptr [CursY],25
Fin:            Ret

; Le message qui fait peur (qui tue ?)
IntroMessage    Db '  Runtime ERROR fanzine - Developpement System v1.0 - (c) copyright 1995  ','$'
; Basse imitation du DOS (pour le >)
CharWrite       Db '>','$'

Boot:           Mov ax,0003h      ; On passe en mode texte (+efface cran)
                Int 10h
                Mov ah,01h
                Mov cx,1514h
                Int 10h           ; On fait disparaitre le curseur tout moche
                Mov Attrib,1Eh
                Mov dx,Offset IntroMessage
                Call RAMWrite     ; On crit le message d'intro
                Mov attrib,15
                Mov dx,Offset CharWrite
                Mov CursY,3
                Mov CursX,0
                Call RAMWrite     ; On crit ">"
LoopRW:         Mov ah,0
                Int 16h                   ; on attend frappe d'une touche
                Mov Byte ptr CharWrite,al ; ASCII code dans charwrite
                Mov dx,Offset CharWrite
                Call RAMWrite             ; on crit le caractre
                Jmp loopRW                ; et on recommence

MAIN ENDS           ; snif ! on se quitte.
END START
